Index: netwerk/cookie/src/nsCookieService.cpp
===================================================================
RCS file: /cvsroot/mozilla/netwerk/cookie/src/nsCookieService.cpp,v
retrieving revision 1.57
diff -p -U 8 -r1.57 nsCookieService.cpp
--- netwerk/cookie/src/nsCookieService.cpp	7 May 2007 11:14:01 -0000	1.57
+++ netwerk/cookie/src/nsCookieService.cpp	14 May 2007 09:24:21 -0000
@@ -18,16 +18,17 @@
  * The Initial Developer of the Original Code is
  * Netscape Communications Corporation.
  * Portions created by the Initial Developer are Copyright (C) 2003
  * the Initial Developer. All Rights Reserved.
  *
  * Contributor(s):
  *   Daniel Witte (dwitte@stanford.edu)
  *   Michiel van Leeuwen (mvl@exedo.nl)
+ *   Loune Lam (lpgcritter at nasquan dot com)
  *
  * Alternatively, the contents of this file may be used under the terms of
  * either the GNU General Public License Version 2 or later (the "GPL"), or
  * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
  * in which case the provisions of the GPL or the LGPL are applicable instead
  * of those above. If you wish to allow use of your version of this file only
  * under the terms of either the GPL or the LGPL, and not to allow others to
  * use your version of this file under the terms of the MPL, indicate your
@@ -64,38 +65,30 @@
 #include "nsReadableUtils.h"
 #include "nsCRT.h"
 #include "prtime.h"
 #include "prprf.h"
 #include "prnetdb.h"
 #include "nsNetUtil.h"
 #include "nsNetCID.h"
 #include "nsAppDirectoryServiceDefs.h"
+#include "nsIArray.h"
+#include "nsIMutableArray.h"
+#include "nsArrayUtils.h"
 
 /******************************************************************************
  * nsCookieService impl:
  * useful types & constants
  ******************************************************************************/
 
-// XXX_hack. See bug 178993.
-// This is a hack to hide HttpOnly cookies from older browsers
-//
-static const char kHttpOnlyPrefix[] = "#HttpOnly_";
-
-static const char kCookieFileName[] = "cookies.txt";
-
-static const PRUint32 kLazyWriteTimeout = 5000; //msec
-
 #undef  LIMIT
 #define LIMIT(x, low, high, default) ((x) >= (low) && (x) <= (high) ? (x) : (default))
 
 // default limits for the cookie list. these can be tuned by the
 // network.cookie.maxNumber and network.cookie.maxPerHost prefs respectively.
-static const PRUint32 kMaxNumberOfCookies = 1000;
-static const PRUint32 kMaxCookiesPerHost  = 50;
 static const PRUint32 kMaxBytesPerCookie  = 4096;
 static const PRUint32 kMaxBytesPerPath    = 1024;
 
 // this constant augments those defined on nsICookie, and indicates
 // the cookie should be rejected because of an error (rather than
 // something the user can control). this is used for notifying about
 // rejected cookies, since we only want to notify of rejections where
 // the user can do something about it (e.g. whitelist the site).
@@ -111,78 +104,33 @@ static const PRUint32 BEHAVIOR_ACCEPT   
 static const PRUint32 BEHAVIOR_REJECTFOREIGN = 1;
 static const PRUint32 BEHAVIOR_REJECT        = 2;
 static const PRUint32 BEHAVIOR_P3P           = 3;
 
 // pref string constants
 static const char kPrefCookiesPermissions[] = "network.cookie.cookieBehavior";
 static const char kPrefMaxNumberOfCookies[] = "network.cookie.maxNumber";
 static const char kPrefMaxCookiesPerHost[]  = "network.cookie.maxPerHost";
+static const char kInitialCookieContainerId[] = "@mozilla.org/cookie-container;1#MAIN";
 
 // struct for temporarily storing cookie attributes during header parsing
 struct nsCookieAttributes
 {
   nsCAutoString name;
   nsCAutoString value;
   nsCAutoString host;
   nsCAutoString path;
   nsCAutoString expires;
   nsCAutoString maxage;
   nsInt64 expiryTime;
   PRBool isSession;
   PRBool isSecure;
   PRBool isHttpOnly;
 };
 
-// stores linked list iteration state, and provides a rudimentary
-// list traversal method
-struct nsListIter
-{
-  nsListIter() {}
-
-  nsListIter(nsCookieEntry *aEntry)
-   : entry(aEntry)
-   , prev(nsnull)
-   , current(aEntry ? aEntry->Head() : nsnull) {}
-
-  nsListIter(nsCookieEntry *aEntry,
-             nsCookie      *aPrev,
-             nsCookie      *aCurrent)
-   : entry(aEntry)
-   , prev(aPrev)
-   , current(aCurrent) {}
-
-  nsListIter& operator++() { prev = current; current = current->Next(); return *this; }
-
-  nsCookieEntry *entry;
-  nsCookie      *prev;
-  nsCookie      *current;
-};
-
-// stores temporary data for enumerating over the hash entries,
-// since enumeration is done using callback functions
-struct nsEnumerationData
-{
-  nsEnumerationData(nsInt64 aCurrentTime,
-                    PRInt64 aOldestTime)
-   : currentTime(aCurrentTime)
-   , oldestTime(aOldestTime)
-   , iter(nsnull, nsnull, nsnull) {}
-
-  // the current time
-  nsInt64 currentTime;
-
-  // oldest lastAccessed time in the cookie list. use aOldestTime = LL_MAXINT
-  // to enable this search, LL_MININT to disable it.
-  nsInt64 oldestTime;
-
-  // an iterator object that points to the desired cookie
-  nsListIter iter;
-};
-
 /******************************************************************************
  * Cookie logging handlers
  * used for logging in nsCookieService
  ******************************************************************************/
 
 // logging handlers
 #ifdef MOZ_LOGGING
 // in order to do logging, the following environment variables need to be set:
@@ -368,440 +316,364 @@ nsCookieService::GetSingleton()
     if (NS_FAILED(gCookieService->Init())) {
       NS_RELEASE(gCookieService);
     }
   }
 
   return gCookieService;
 }
 
+NS_METHOD
+nsCookieService::GetDefaultContainer(nsISupports* aOuter, const nsIID& aIID, void* *aResult)
+{
+  nsresult rv;
+  
+  if (aOuter != nsnull)
+    return NS_ERROR_NO_AGGREGATION;
+
+  nsCookieService *svc = GetSingleton(); // ref added in the getter
+
+  nsCOMPtr<nsICookieContainer> container;
+  rv = svc->GetDefaultContainer(getter_AddRefs(container));
+  if (NS_FAILED(rv)) return rv;;
+  NS_RELEASE(svc);
+
+  rv = container->QueryInterface(aIID, aResult);
+
+  return rv;
+}
+
 /******************************************************************************
  * nsCookieService impl:
  * public methods
  ******************************************************************************/
 
-NS_IMPL_ISUPPORTS6(nsCookieService,
+NS_IMPL_ISUPPORTS3(nsCookieService,
                    nsICookieService,
-                   nsICookieServiceInternal,
-                   nsICookieManager,
-                   nsICookieManager2,
                    nsIObserver,
                    nsISupportsWeakReference)
 
 nsCookieService::nsCookieService()
- : mCookieCount(0)
- , mCookieChanged(PR_FALSE)
- , mCookieIconVisible(PR_FALSE)
+ : mCookieIconVisible(PR_FALSE)
  , mCookiesPermissions(BEHAVIOR_ACCEPT)
- , mMaxNumberOfCookies(kMaxNumberOfCookies)
- , mMaxCookiesPerHost(kMaxCookiesPerHost)
+ , mDefaultContainerId(kInitialCookieContainerId)
 {
 }
 
 nsresult
 nsCookieService::Init()
 {
-  if (!mHostTable.Init()) {
+  if (!mContainerTable.Init()) {
     return NS_ERROR_OUT_OF_MEMORY;
   }
 
   // init our pref and observer
   nsCOMPtr<nsIPrefBranch2> prefBranch = do_GetService(NS_PREFSERVICE_CONTRACTID);
   if (prefBranch) {
     prefBranch->AddObserver(kPrefCookiesPermissions, this, PR_TRUE);
     prefBranch->AddObserver(kPrefMaxNumberOfCookies, this, PR_TRUE);
     prefBranch->AddObserver(kPrefMaxCookiesPerHost,  this, PR_TRUE);
-    PrefChanged(prefBranch);
-  }
-
-  // cache mCookieFile
-  NS_GetSpecialDirectory(NS_APP_USER_PROFILE_50_DIR, getter_AddRefs(mCookieFile));
-  if (mCookieFile) {
-    mCookieFile->AppendNative(NS_LITERAL_CSTRING(kCookieFileName));
+    Observe(prefBranch, NS_PREFBRANCH_PREFCHANGE_TOPIC_ID, nsnull);
   }
 
-  Read();
-
   mObserverService = do_GetService("@mozilla.org/observer-service;1");
   if (mObserverService) {
     mObserverService->AddObserver(this, "profile-before-change", PR_TRUE);
     mObserverService->AddObserver(this, "profile-do-change", PR_TRUE);
     mObserverService->AddObserver(this, "cookieIcon", PR_TRUE);
+    mObserverService->AddObserver(this, "cookie-changed", PR_TRUE);
   }
 
   mPermissionService = do_GetService(NS_COOKIEPERMISSION_CONTRACTID);
 
+  // create initial cookie container
+  nsCOMPtr<nsICookieContainer> container;
+  GetDefaultContainer(getter_AddRefs(container));
+
   return NS_OK;
 }
 
 nsCookieService::~nsCookieService()
 {
   gCookieService = nsnull;
+}
 
-  if (mWriteTimer)
-    mWriteTimer->Cancel();
+PR_STATIC_CALLBACK(PLDHashOperator)
+containersNotifyCallback(const char* aKey, nsICookieContainer* aData, void* userArg)
+{
+  nsCOMPtr<nsIObserver> observer = do_QueryInterface(aData);
+  if (observer) {
+    observer->Observe(NS_REINTERPRET_CAST(nsISupports*, ((void**)userArg)[0]), 
+        NS_REINTERPRET_CAST(const char*, ((void**)userArg)[1]),
+        NS_REINTERPRET_CAST(const PRUnichar *, ((void**)userArg)[2]));
+  }
+  return PL_DHASH_NEXT;
 }
 
 NS_IMETHODIMP
 nsCookieService::Observe(nsISupports     *aSubject,
                          const char      *aTopic,
                          const PRUnichar *aData)
 {
   // check the topic
-  if (!nsCRT::strcmp(aTopic, "profile-before-change")) {
-    // The profile is about to change,
-    // or is going away because the application is shutting down.
-    if (mWriteTimer) {
-      mWriteTimer->Cancel();
-      mWriteTimer = 0;
-    }
-
-    if (!nsCRT::strcmp(aData, NS_LITERAL_STRING("shutdown-cleanse").get())) {
-      RemoveAllFromMemory();
-      // delete the cookie file
-      if (mCookieFile) {
-        mCookieFile->Remove(PR_FALSE);
-      }
-    } else {
-      Write();
-      RemoveAllFromMemory();
-    }
-
-  } else if (!nsCRT::strcmp(aTopic, "profile-do-change")) {
-    // The profile has already changed.    
-    // Now just read them from the new profile location.
-    // we also need to update the cached cookie file location
-    nsresult rv = NS_GetSpecialDirectory(NS_APP_USER_PROFILE_50_DIR, getter_AddRefs(mCookieFile));
-    if (NS_SUCCEEDED(rv)) {
-      mCookieFile->AppendNative(NS_LITERAL_CSTRING(kCookieFileName));
-    }
-    Read();
-
-  } else if (!nsCRT::strcmp(aTopic, "cookieIcon")) {
+  if (!nsCRT::strcmp(aTopic, "cookieIcon")) {
     // this is an evil trick to avoid the blatant inefficiency of
     // (!nsCRT::strcmp(aData, NS_LITERAL_STRING("on").get()))
     mCookieIconVisible = (aData[0] == 'o' && aData[1] == 'n' && aData[2] == '\0');
 
-  } else if (!nsCRT::strcmp(aTopic, NS_PREFBRANCH_PREFCHANGE_TOPIC_ID)) {
-    nsCOMPtr<nsIPrefBranch> prefBranch = do_QueryInterface(aSubject);
-    if (prefBranch)
-      PrefChanged(prefBranch);
+  } else if (!nsCRT::strcmp(aTopic, "profile-before-change") ||
+      !nsCRT::strcmp(aTopic, "profile-do-change") ||
+      !nsCRT::strcmp(aTopic, NS_PREFBRANCH_PREFCHANGE_TOPIC_ID)) {
+
+    if (!nsCRT::strcmp(aTopic, NS_PREFBRANCH_PREFCHANGE_TOPIC_ID)) {
+      // prefs changed, update default permissions
+      nsCOMPtr<nsIPrefBranch> prefBranch = do_QueryInterface(aSubject);
+      if (prefBranch) {
+        mCookiesPermissions = BEHAVIOR_ACCEPT; // default
+        PRInt32 val;
+        if (NS_SUCCEEDED(prefBranch->GetIntPref(kPrefCookiesPermissions, &val)))
+          mCookiesPermissions = LIMIT(val, 0, 3, 0);
+      }
+    }
+    // relay notification to containers
+    void* args[3];
+    args[0] = aSubject;
+    args[1] = (void *)aTopic;
+    args[2] = (void *)aData;
+    mContainerTable.EnumerateRead(containersNotifyCallback, &args);
+
+  } else if (!nsCRT::strcmp(aTopic, "cookie-changed")) {
+    // legacy code originally in NotifyChanged()
+
+    // fire a cookieIcon notification if the cookie was downgraded or flagged
+    // by p3p. the cookieIcon notification is now deprecated, but we still need
+    // this until consumers can be fixed. to see if cookies have been
+    // downgraded or flagged, listen to cookie-changed directly.
+    nsCOMPtr<nsICookie2> cookie = do_QueryInterface(aSubject);
+    if (mCookiesPermissions == BEHAVIOR_P3P &&
+        (!nsCRT::strcmp(aData, NS_LITERAL_STRING("added").get()) ||
+         !nsCRT::strcmp(aData, NS_LITERAL_STRING("changed").get()))) {
+      nsCookieStatus status;
+      cookie->GetStatus(&status);
+      if (status == nsICookie::STATUS_DOWNGRADED ||
+          status == nsICookie::STATUS_FLAGGED) {
+        mCookieIconVisible = PR_TRUE;
+        if (mObserverService)
+          mObserverService->NotifyObservers(nsnull, "cookieIcon", NS_LITERAL_STRING("on").get());
+      }
+    }
   }
 
   return NS_OK;
 }
 
-// helper function for GetCookieList
-static inline PRBool ispathdelimiter(char c) { return c == '/' || c == '?' || c == '#' || c == ';'; }
 
-void
-nsCookieService::GetCookieList(nsIURI           *aHostURI,
-                               nsIURI           *aFirstURI,
-                               nsIChannel       *aChannel,
-                               const nsACString *aName,
-                               PRBool           aHttpBound,
-                               nsAutoVoidArray  &aResult)
+/* attribute string containerId; */
+NS_IMETHODIMP
+nsCookieService::SetDefaultContainer(nsICookieContainer *aContainer)
 {
-  if (!aHostURI) {
-    COOKIE_LOGFAILURE(GET_COOKIE, nsnull, nsnull, "host URI is null");
-    return;
-  }
-
-  // check default prefs
-  nsCookiePolicy cookiePolicy; // we don't use this here... just a placeholder
-  nsCookieStatus cookieStatus = CheckPrefs(aHostURI, aFirstURI, aChannel, nsnull, cookiePolicy);
-  // for GetCookie(), we don't fire rejection notifications.
-  switch (cookieStatus) {
-  case nsICookie::STATUS_REJECTED:
-  case STATUS_REJECTED_WITH_ERROR:
-    return;
-  }
-
-  // get host and path from the nsIURI
-  // note: there was a "check if host has embedded whitespace" here.
-  // it was removed since this check was added into the nsIURI impl (bug 146094).
-  nsCAutoString hostFromURI, pathFromURI;
-  if (NS_FAILED(aHostURI->GetAsciiHost(hostFromURI)) ||
-      NS_FAILED(aHostURI->GetPath(pathFromURI))) {
-    COOKIE_LOGFAILURE(GET_COOKIE, aHostURI, nsnull, "couldn't get host/path from URI");
-    return;
-  }
-  // trim trailing dots
-  hostFromURI.Trim(".");
-  // insert a leading dot, so we begin the hash lookup with the
-  // equivalent domain cookie host
-  hostFromURI.Insert(NS_LITERAL_CSTRING("."), 0);
-  ToLowerCase(hostFromURI);
-
-  // check if aHostURI is using an https secure protocol.
-  // if it isn't, then we can't send a secure cookie over the connection.
-  // if SchemeIs fails, assume an insecure connection, to be on the safe side
-  PRBool isSecure;
-  if (NS_FAILED(aHostURI->SchemeIs("https", &isSecure))) {
-    isSecure = PR_FALSE;
-  }
-
-  nsCookie *cookie;
-  nsInt64 currentTime = NOW_IN_SECONDS;
-  const char *currentDot = hostFromURI.get();
-  const char *nextDot = currentDot + 1;
-
-  // begin hash lookup, walking up the subdomain levels.
-  // we use nextDot to force a lookup of the original host (without leading dot).
-  do {
-    nsCookieEntry *entry = mHostTable.GetEntry(currentDot);
-    cookie = entry ? entry->Head() : nsnull;
-    for (; cookie; cookie = cookie->Next()) {
-      // check the cookie name, if appropriate
-      if (aName && !aName->Equals(cookie->Name())) {
-        continue;
-      }
-
-      // if the cookie is secure and the host scheme isn't, we can't send it
-      if (cookie->IsSecure() && !isSecure) {
-        continue;
-      }
-
-      // if the cookie is httpOnly and it's not going directly to the HTTP
-      // connection, don't send it
-      if (cookie->IsHttpOnly() && !aHttpBound) {
-        continue;
-      }
-
-      // calculate cookie path length, excluding trailing '/'
-      PRUint32 cookiePathLen = cookie->Path().Length();
-      if (cookiePathLen > 0 && cookie->Path().Last() == '/') {
-        --cookiePathLen;
-      }
-
-      // if the nsIURI path is shorter than the cookie path, don't send it back
-      if (!StringBeginsWith(pathFromURI, Substring(cookie->Path(), 0, cookiePathLen))) {
-        continue;
-      }
-
-      if (pathFromURI.Length() > cookiePathLen &&
-          !ispathdelimiter(pathFromURI.CharAt(cookiePathLen))) {
-        /*
-         * |ispathdelimiter| tests four cases: '/', '?', '#', and ';'.
-         * '/' is the "standard" case; the '?' test allows a site at host/abc?def
-         * to receive a cookie that has a path attribute of abc.  this seems
-         * strange but at least one major site (citibank, bug 156725) depends
-         * on it.  The test for # and ; are put in to proactively avoid problems
-         * with other sites - these are the only other chars allowed in the path.
-         */
-        continue;
-      }
-
-      // check if the cookie has expired
-      if (cookie->Expiry() <= currentTime) {
-        continue;
-      }
-
-      // all checks passed - add to list and update lastAccessed stamp of cookie
-      aResult.AppendElement(cookie);
-      cookie->SetLastAccessed(currentTime);
+    if (!aContainer) {
+        mDefaultContainerId.Assign("");
+    } else {
+        char* id;
+        aContainer->GetContainerId(&id);
+        mDefaultContainerId.Assign(id);
+        nsMemory::Free(id);
     }
-
-    currentDot = nextDot;
-    if (currentDot)
-      nextDot = strchr(currentDot + 1, '.');
-
-  } while (currentDot);
-
-  // return cookies in order of path length; longest to shortest.
-  // this is required per RFC2109.  if cookies match in length,
-  // then sort by creation time (see bug 236772).
-  aResult.Sort(compareCookiesForSending, nsnull);
+    return NS_OK;
 }
-
 NS_IMETHODIMP
-nsCookieService::GetCookieValue(nsIURI *aHostURI,
-				nsIChannel *aChannel,
-                                const nsACString& aName,
-				nsACString& aResult)
+nsCookieService::GetDefaultContainer(nsICookieContainer **_retval)
 {
-  aResult.Truncate();
-
-  // try to determine first party URI
-  nsCOMPtr<nsIURI> firstURI;
-  if (aChannel) {
-    nsCOMPtr<nsIHttpChannelInternal> httpInternal = do_QueryInterface(aChannel);
-    if (httpInternal)
-      httpInternal->GetDocumentURI(getter_AddRefs(firstURI));
-  }
+    return GetContainer(mDefaultContainerId.get(), _retval);
+}
 
-  nsAutoVoidArray foundCookieList;
-  GetCookieList(aHostURI, firstURI, aChannel, &aName, PR_FALSE,
-                foundCookieList);
 
-  if (!foundCookieList.Count())
-    return NS_ERROR_NOT_AVAILABLE;
+/* nsICookieContainer getContainer (in string aContainerId); */
+NS_IMETHODIMP
+nsCookieService::GetContainer(const char *aContainerId,
+							  nsICookieContainer **_retval)
+{
+    nsresult rv;
 
-  nsCookie *cookie = NS_STATIC_CAST(nsCookie*, foundCookieList[0]);
+    nsCOMPtr<nsICookieContainer> container;
+    // find and get the container. If not found, create as a new container
+    if (!mContainerTable.Get(aContainerId, getter_AddRefs(container))) {
+        // extract the contractId from container id (everything up to the #)
+        char *contractId = (char *)nsMemory::Alloc(strlen(aContainerId) +1 * sizeof(char));
+        PRInt32 i;
+        for (i = 0; aContainerId[i] != 0 && aContainerId[i] != '#'; i++) {
+            contractId[i] = aContainerId[i];
+        }
+        contractId[i] = 0;
+        container = do_CreateInstance(contractId);
+        nsMemory::Free(contractId);
+        if (!container)
+            return NS_ERROR_FAILURE;
+
+        rv = container->Init(aContainerId);
+        NS_ENSURE_SUCCESS(rv, rv);
+        mContainerTable.Put(aContainerId, container);
+    }
+    *_retval = container;
+    NS_IF_ADDREF(*_retval);
 
-  aResult.Assign(cookie->Value());
-  return NS_OK;
+    return NS_OK;
 }
 
+
 NS_IMETHODIMP
-nsCookieService::GetCookieString(nsIURI     *aHostURI,
+nsCookieService::GetCookieString(nsICookieContainer *aContainer, 
+								 nsIURI     *aHostURI,
                                  nsIChannel *aChannel,
                                  char       **aCookie)
 {
   // try to determine first party URI
   nsCOMPtr<nsIURI> firstURI;
   if (aChannel) {
     nsCOMPtr<nsIHttpChannelInternal> httpInternal = do_QueryInterface(aChannel);
     if (httpInternal)
       httpInternal->GetDocumentURI(getter_AddRefs(firstURI));
   }
 
-  nsAutoVoidArray foundCookieList;
-  GetCookieList(aHostURI, firstURI, aChannel, nsnull, PR_FALSE,
-                foundCookieList);
+  // check default prefs
+  nsCOMPtr<nsICookiePermission> permissionService = do_QueryInterface(aContainer);
+  if (!permissionService)
+    permissionService = mPermissionService;
+  nsCookiePolicy cookiePolicy; // we don't use this here... just a placeholder
+  nsCookieStatus cookieStatus = CheckPrefs(permissionService, aHostURI, firstURI, aChannel, nsnull, cookiePolicy);
+  // for GetCookie(), we don't fire rejection notifications.
+  switch (cookieStatus) {
+  case nsICookie::STATUS_REJECTED:
+  case STATUS_REJECTED_WITH_ERROR:
+    return NS_OK;
+  }
+
+  nsCOMPtr<nsIArray> foundCookieList;
+  aContainer->GetCookieList(aHostURI, nsnull, PR_FALSE,
+                getter_AddRefs(foundCookieList));
   *aCookie = CookieStringFromArray(foundCookieList, aHostURI);
   
   return NS_OK;
 }
 
 NS_IMETHODIMP
-nsCookieService::GetCookieStringFromHttp(nsIURI     *aHostURI,
+nsCookieService::GetCookieStringFromHttp(nsICookieContainer *aContainer, 
+										 nsIURI     *aHostURI,
                                          nsIURI     *aFirstURI,
                                          nsIChannel *aChannel,
                                          char       **aCookie)
 {
-  nsAutoVoidArray foundCookieList;
-  GetCookieList(aHostURI, aFirstURI, aChannel, nsnull, PR_TRUE,
-                foundCookieList);
+  // check default prefs
+  nsCOMPtr<nsICookiePermission> permissionService = do_QueryInterface(aContainer);
+  if (!permissionService)
+    permissionService = mPermissionService;
+  nsCookiePolicy cookiePolicy; // we don't use this here... just a placeholder
+  nsCookieStatus cookieStatus = CheckPrefs(permissionService, aHostURI, aFirstURI, aChannel, nsnull, cookiePolicy);
+  // for GetCookie(), we don't fire rejection notifications.
+  switch (cookieStatus) {
+  case nsICookie::STATUS_REJECTED:
+  case STATUS_REJECTED_WITH_ERROR:
+    return NS_OK;
+  }
+
+  nsCOMPtr<nsIArray> foundCookieList;
+  aContainer->GetCookieList(aHostURI, nsnull, PR_TRUE,
+                getter_AddRefs(foundCookieList));
   *aCookie = CookieStringFromArray(foundCookieList, aHostURI);
 
   return NS_OK;
 }
 
 char*
-nsCookieService::CookieStringFromArray(const nsAutoVoidArray& aCookieList,
+nsCookieService::CookieStringFromArray(nsIArray *aCookieList,
                                        nsIURI *aHostURI)
 {
-  nsCAutoString cookieData;
-  PRInt32 count = aCookieList.Count();
-  for (PRInt32 i = 0; i < count; ++i) {
-    nsCookie *cookie = NS_STATIC_CAST(nsCookie*, aCookieList.ElementAt(i));
+  nsCAutoString cookieData, cookieName, cookieValue;
+  PRUint32 count = 0;
+  aCookieList->GetLength(&count);
+  for (PRUint32 i = 0; i < count; ++i) {
+    nsCOMPtr<nsCookie> cookie = do_QueryElementAt(aCookieList, i);
+    cookie->GetName(cookieName);
+    cookie->GetValue(cookieValue);
 
     // check if we have anything to write
-    if (!cookie->Name().IsEmpty() || !cookie->Value().IsEmpty()) {
+    if (!cookieName.IsEmpty() || !cookieValue.IsEmpty()) {
       // if we've already added a cookie to the return list, append a "; " so
       // that subsequent cookies are delimited in the final list.
       if (!cookieData.IsEmpty()) {
         cookieData.AppendLiteral("; ");
       }
 
-      if (!cookie->Name().IsEmpty()) {
+      if (!cookieName.IsEmpty()) {
         // we have a name and value - write both
-        cookieData += cookie->Name() + NS_LITERAL_CSTRING("=") + cookie->Value();
+        cookieData += cookieName + NS_LITERAL_CSTRING("=") + cookieValue;
       } else {
         // just write value
-        cookieData += cookie->Value();
+        cookieData += cookieValue;
       }
     }
   }
 
   // it's wasteful to alloc a new string; but we have no other choice, until we
   // fix the callers to use nsACStrings.
   if (!cookieData.IsEmpty()) {
     COOKIE_LOGSUCCESS(GET_COOKIE, aHostURI, cookieData, nsnull);
     return ToNewCString(cookieData);
   }
   
   return nsnull;
 }
 
 NS_IMETHODIMP
-nsCookieService::SetCookieValue(nsIURI *aHostURI,
-                                nsIChannel *aChannel,
-                                const nsACString& aDomain,
-                                const nsACString& aPath,
-                                const nsACString& aName,
-                                const nsACString& aValue,
-                                PRBool aIsSession,
-                                PRInt64 aExpiry)
-{
-  // try to determine first party URI
-  nsCOMPtr<nsIURI> firstURI;
-
-  if (aChannel) {
-    nsCOMPtr<nsIHttpChannelInternal> httpInternal = do_QueryInterface(aChannel);
-    if (httpInternal)
-      httpInternal->GetDocumentURI(getter_AddRefs(firstURI));
-  }
-
-  // check default prefs
-  nsCookiePolicy cookiePolicy = nsICookie::POLICY_UNKNOWN;
-  nsCookieStatus cookieStatus = CheckPrefs(aHostURI, firstURI, aChannel, "", cookiePolicy);
-  // fire a notification if cookie was rejected (but not if there was an error)
-  switch (cookieStatus) {
-  case nsICookie::STATUS_REJECTED:
-    NotifyRejected(aHostURI);
-  case STATUS_REJECTED_WITH_ERROR:
-    return NS_OK;
-  }
-
-  nsCookieAttributes attributes;
-  attributes.name = aName;
-  attributes.value = aValue;
-  attributes.host = aDomain;
-  attributes.path = aPath;
-  attributes.expiryTime = aExpiry;
-  attributes.isSession = aIsSession;
-
-  attributes.isSecure = PR_FALSE;
-  aHostURI->SchemeIs("https", &attributes.isSecure);
-
-  CheckAndAdd(aHostURI, aChannel, attributes,
-              cookieStatus, cookiePolicy, EmptyCString());
-  return NS_OK;
-}
-
-NS_IMETHODIMP
-nsCookieService::SetCookieString(nsIURI     *aHostURI,
+nsCookieService::SetCookieString(nsICookieContainer *aContainer, 
+								 nsIURI     *aHostURI,
                                  nsIPrompt  *aPrompt,
                                  const char *aCookieHeader,
                                  nsIChannel *aChannel)
 {
   // try to determine first party URI
   nsCOMPtr<nsIURI> firstURI;
 
   if (aChannel) {
     nsCOMPtr<nsIHttpChannelInternal> httpInternal = do_QueryInterface(aChannel);
     if (httpInternal)
       httpInternal->GetDocumentURI(getter_AddRefs(firstURI));
   }
 
-  return SetCookieStringFromHttp(aHostURI, firstURI, aPrompt, aCookieHeader, nsnull, aChannel);
+  return SetCookieStringFromHttp(aContainer, aHostURI, firstURI, aPrompt, aCookieHeader, nsnull, aChannel);
 }
 
 NS_IMETHODIMP
-nsCookieService::SetCookieStringFromHttp(nsIURI     *aHostURI,
+nsCookieService::SetCookieStringFromHttp(nsICookieContainer *aContainer, 
+										 nsIURI     *aHostURI,
                                          nsIURI     *aFirstURI,
                                          nsIPrompt  *aPrompt,
                                          const char *aCookieHeader,
                                          const char *aServerTime,
                                          nsIChannel *aChannel) 
 {
   if (!aHostURI) {
     COOKIE_LOGFAILURE(SET_COOKIE, nsnull, aCookieHeader, "host URI is null");
     return NS_OK;
   }
 
   // check default prefs
+  nsCOMPtr<nsICookiePermission> permissionService = do_QueryInterface(aContainer);
+  if (!permissionService)
+    permissionService = mPermissionService;
   nsCookiePolicy cookiePolicy = nsICookie::POLICY_UNKNOWN;
-  nsCookieStatus cookieStatus = CheckPrefs(aHostURI, aFirstURI, aChannel, aCookieHeader, cookiePolicy);
+  nsCookieStatus cookieStatus = CheckPrefs(permissionService, aHostURI, aFirstURI, aChannel, aCookieHeader, cookiePolicy);
   // fire a notification if cookie was rejected (but not if there was an error)
   switch (cookieStatus) {
   case nsICookie::STATUS_REJECTED:
-    NotifyRejected(aHostURI);
+    char *cid;
+    aContainer->GetContainerId(&cid);
+    NotifyRejected(aHostURI, NS_ConvertASCIItoUTF16(cid).get());
+    nsMemory::Free(cid);
   case STATUS_REJECTED_WITH_ERROR:
     return NS_OK;
   }
 
   // parse server local time. this is not just done here for efficiency
   // reasons - if there's an error parsing it, and we need to default it
   // to the current time, we must do it here since the current time in
   // SetCookieInternal() will change for each cookie processed (e.g. if the
